﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Infragistics.MultiTouch.Gestures
{

    /// <summary>
    /// Event handler delegate for gesture events.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public delegate void GestureEventHandler(object sender, GestureEventArgs e);

    /// <summary>
    /// Event arguments for gesture events.
    /// </summary>
    public class GestureEventArgs : EventArgs
	{
		#region Constructor
		/// <summary>
		/// Initializes a new instance of the <see cref="GestureEventArgs"/> class.
		/// </summary>
		/// <param name="gesture">The gesture.</param>
		public GestureEventArgs(Gesture gesture)
        {
            this.Gesture = gesture;
        }
		#endregion Constructor

		#region Public Properties
		/// <summary>
		/// Gets or sets the gesture.
		/// </summary>
		/// <value>The gesture.</value>
		public Gesture Gesture { get; private set; }
		#endregion Public Properties

	}
}
