﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace Infragistics.MultiTouch.Gestures
{
    public interface IGestureProvider
    {

        /// <summary>
        /// The event raised when a direction change is detected.
        /// </summary>
        event GestureEventHandler GestureDirectionChanged;

        /// <summary>
        /// Gets a value indicating if the provider is currently in point capture mode.
        /// </summary>
        bool IsCapturing { get; }

        /// <summary>
        /// Starts a new capture.
        /// </summary>
        /// <param name="startPoint"></param>
        void StartCapture(Point startPoint);

        /// <summary>
        /// Ends the current capture and returns the completed gesture.
        /// </summary>
        /// <returns></returns>
        Gesture StopCapture();

        /// <summary>
        /// Captures a point.
        /// </summary>
        /// <param name="point"></param>
        void CapturePoint(Point point);

    }
}
