﻿using System.Windows;
using System.Windows.Interactivity;
using System.Windows.Media.Animation;

namespace Infragistics.Silverlight.Applications.Stocks.Behaviors
{
    public class StoryboardTrigger : TriggerAction<FrameworkElement>
    {
        #region Dependency Properties
        public static DependencyProperty ElementNameProperty = DependencyProperty.Register("ElementName", typeof(string), typeof(StoryboardTrigger), null);
        public string ElementName { get { return (string)GetValue(ElementNameProperty); } set { SetValue(ElementNameProperty, value); } }

        public static DependencyProperty StoryboardNameProperty = DependencyProperty.Register("StoryboardName", typeof(string), typeof(StoryboardTrigger), null);
        public string StoryboardName { get { return (string)GetValue(StoryboardNameProperty); } set { SetValue(StoryboardNameProperty, value); } }
        #endregion Dependency Properties

        #region Protected Overrides
        /// <summary>
        /// Called when [attached].
        /// </summary>
        protected override void OnAttached()
        {
            base.OnAttached();
        }

        /// <summary>
        /// Called when [detaching].
        /// </summary>
        protected override void OnDetaching()
        {
            base.OnDetaching();
        }

        /// <summary>
        /// Invokes the specified parameter.
        /// </summary>
        /// <param name="parameter">The parameter.</param>
        protected override void Invoke(object parameter)
        {
            var rootElement = (FrameworkElement)Application.Current.RootVisual;

            if (rootElement != null)
            {
                var fe = rootElement.FindVisualChildByName<FrameworkElement>(ElementName);

                if (fe != null)
                {
                    var storyboard = fe.Resources[StoryboardName] as Storyboard;

                    if (storyboard != null)
                    {
                        storyboard.Begin();
                    }
                }
            }
            
            
            
        }
        #endregion Protected Overrides
    }
}