﻿using System;
using System.Linq;
using System.Windows;

namespace Infragistics.Silverlight.Applications.Stocks.Services
{
	public class ServiceLocator
	{
		public static T GetInstance<T>()
			where T : class
		{
			var result = (from IApplicationService item in Application.Current.ApplicationLifetimeObjects
						 where item is T
						 select item).DefaultIfEmpty(null).FirstOrDefault();
			
			return result as T;
		}
	}
}
