﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using Infragistics.Silverlight.Applications.Stocks.ViewModels;

namespace Infragistics.Silverlight.Applications.Stocks.Views
{
    public partial class LandscapeView : UserControl
    {
        private StockViewModel _vm;
        
        public LandscapeView()
        {
            InitializeComponent();
            Loaded += LandscapeViewLoaded;
        }

        private void LandscapeViewLoaded(object sender, RoutedEventArgs e)
        {
            _vm = (StockViewModel) DataContext;
            RefreshChart();
            _vm.PropertyChanged += ViewModelPropertyChanged;
        }

        private void ViewModelPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Tickers")
            {
                RefreshChart();    
            }
        }

        private void RefreshChart()
        {
            LandscapeChart.Series.Clear();
            foreach (var ticker in _vm.Tickers)
            {
                var series = new LineSeries()
                {
                    ValueMemberPath = "Close",
                    MarkerType = MarkerType.None
                };
                series.SetBinding(LineSeries.ItemsSourceProperty, new Binding("FilteredData") { Source = ticker });
                series.SetBinding(LineSeries.BrushProperty, new Binding("Brush") { Source = ticker });
                series.SetBinding(LineSeries.XAxisProperty, new Binding() { ElementName = "xStockValue" });
                series.SetBinding(LineSeries.YAxisProperty, new Binding() { ElementName = "yStockValue" });
                LandscapeChart.Series.Add(series);
            }
        }
    }
}
